config/routes.rb
Rails.application.routes.draw do
  resources :books
  resources :assets
  resources :categories
  resources :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root to: 'books#index'
end

app/models/asset.rb
class Asset 
  include Neo4j::ActiveNode
  property :title, type: String



end

app/controllers/assets_controller.rb
class AssetsController < ApplicationController
  before_action :set_asset, only: [:show, :edit, :update, :destroy]

  # GET /assets
  # GET /assets.json
  def index
    @searchText = params[:site_search].present? ? params[:site_search].strip : nil
    begin
     @search_result = Searchkick.search(@searchText,
      index_name: [Book],
      load: false,
      page: params[:page],
      per_page: 10)
    rescue => e
      Rails.logger.info e.to_s
      @search_result = nil
    end
    #@assets = Asset.all
  end

  # GET /assets/1
  # GET /assets/1.json
  def show
  end

  # GET /assets/new
  def new
    @asset = Asset.new
  end

  # GET /assets/1/edit
  def edit
  end

  # POST /assets
  # POST /assets.json
  def create
    @asset = Asset.new(asset_params)

    respond_to do |format|
      if @asset.save
        format.html { redirect_to @asset, notice: 'Asset was successfully created.' }
        format.json { render :show, status: :created, location: @asset }
      else
        format.html { render :new }
        format.json { render json: @asset.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /assets/1
  # PATCH/PUT /assets/1.json
  def update
    respond_to do |format|
      if @asset.update(asset_params)
        format.html { redirect_to @asset, notice: 'Asset was successfully updated.' }
        format.json { render :show, status: :ok, location: @asset }
      else
        format.html { render :edit }
        format.json { render json: @asset.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /assets/1
  # DELETE /assets/1.json
  def destroy
    @asset.destroy
    respond_to do |format|
      format.html { redirect_to assets_url, notice: 'Asset was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_asset
      @asset = Asset.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def asset_params
      params.require(:asset).permit(:title)
    end
end

app/helpers/assets_helper.rb
module AssetsHelper
end

app/views/assets/_form.html.erb
<%= form_for(asset) do |f| %>
  <% if asset.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(asset.errors.count, "error") %> prohibited this asset from being saved:</h2>

      <ul>
      <% asset.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :title %>
    <%= f.text_field :title %>
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/assets/edit.html.erb
<h1>Editing Asset</h1>

<%= render 'form', asset: @asset %>

<%= link_to 'Show', @asset %> |
<%= link_to 'Back', assets_path %>

app/views/assets/index.html.erb
<h1>Search Result</h1>
<% if @search_result.blank? %>
    <div class="uc-no-result-found">
      <p><%= "NO SEARCH RESULT AVAILABLE" %></p>
    </div>
  <% else %>
<table class="table table-bordered">
  <thead>
    <tr>
      <th>Title</th>
      <th>Author</th>
      <th>Email</th>
      <th>Year</th>
      <th>ISBN</th>
      <th>Categories</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @search_result.each do |search_record| %>
      <tr>
        <td><%= search_record["title"] %></td>
        <td><%= search_record["author"] %></td>
        <td><%= search_record["email"] %></td>
        <td><%= search_record["year_published"] %></td>
        <td><%= search_record["isbn"] %></td>
        <td>
        <ul>
          <% search_record["categories"].each do |category| %>
            <li><%= category %></li>
          <% end %>
          </ul>
        </td>
      </tr>
    <% end %>
    <%= paginate @search_result %>
  </tbody>
</table>

<br>
<% end %>
<%= link_to 'Back', books_path, class: 'btn btn-primary' if params[:query].present? %>

app/views/assets/new.html.erb
<h1>New Asset</h1>

<%= render 'form', asset: @asset %>

<%= link_to 'Back', assets_path %>

app/views/assets/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @asset.title %>
</p>

<%= link_to 'Edit', edit_asset_path(@asset) %> |
<%= link_to 'Back', assets_path %>